package geo.tools;

public class GeoPath {
    private String name;
    private String pathCoordinates;

    public void setName(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public void setPathCoordinates(String pathCoordinates) {
        this.pathCoordinates = pathCoordinates;
    }

    public String getPathCoordinates() {
        return pathCoordinates;
    }

    public long getLengthInMeters() {
        String[] pathCoordinatesElements = pathCoordinates.split(" ");

        if (pathCoordinatesElements.length < 4) {
            return 0L;
        }

        long length = 0;

        for (int i = 0; i < pathCoordinatesElements.length - 4; i += 2) {
            double lat1 = Float.parseFloat(pathCoordinatesElements[i]);
            double lon1 = Float.parseFloat(pathCoordinatesElements[i + 1]);
            double lat2 = Float.parseFloat(pathCoordinatesElements[i + 2]);
            double lon2 = Float.parseFloat(pathCoordinatesElements[i + 3]);
            length += distanceInMeters(lat1, lon1, lat2, lon2);
        }

        return length;
    }

    // Lifted from http://www.zipcodeworld.com/samples/distance.java.txt
    private double distanceInMeters(double lat1, double lon1, double lat2, double lon2) {
        double theta = lon1 - lon2;
        double dist = Math.sin(deg2rad(lat1)) * Math.sin(deg2rad(lat2)) + Math.cos(deg2rad(lat1)) * Math.cos(deg2rad(lat2))
                * Math.cos(deg2rad(theta));
        dist = Math.acos(dist);
        dist = rad2deg(dist);
        dist = dist * 60 * 1.1515 * 1609.344;
        return (dist);
    }

    private double deg2rad(double deg) {
        return (deg * Math.PI / 180.0);
    }

    private double rad2deg(double rad) {
        return (rad * 180 / Math.PI);
    }

    public static void main(String[] args) {
        GeoPath geoPath = new GeoPath();
        geoPath
                .setPathCoordinates("49.2790800605625 -123.129181117069 49.2787342619316 -123.128646583203 49.2784201233951 -123.128160987633 49.2781061534841 -123.127675659765 49.2777920654724 -123.127190159213 49.2774780834227 -123.12670485747 49.2771505216185 -123.126198547174 49.2768227959285 -123.125691995584 49.2765088973618 -123.125206822735 49.2761945650737 -123.124721668157 49.2758799523389 -123.124236092335 49.275565804427 -123.123751224783 49.2752516633 -123.123266404436");

        System.out.println(geoPath.getLengthInMeters());
    }

}
