package geo.tools;

import java.util.ArrayList;
import java.util.List;

public class GeoPaths {
    private List<GeoPath> paths = new ArrayList<GeoPath>();

    public List<GeoPath> getPaths() {
        return paths;
    }

    public void setPaths(List<GeoPath> paths) {
        this.paths = paths;
    }

    public long getLengthInMeters() {
        if (paths == null) {
            return 0L;
        }

        long length = 0;

        for (GeoPath path : paths) {
            length += path.getLengthInMeters();
        }

        return length;
    }

    @Override
    public String toString() {
        if (paths == null) {
            return "No geo paths";
        }

        return "\n" + paths.size() + " geo paths for a total length of: " + getLengthInMeters() + " meters.\n\n";
    }
}
